#ifndef _I8051RAM_
#define _I8051RAM_

#include <string>
#include "i8051_const.h"


//----------------------------------------------------------------

class RamAddrStat {
public:
  char data;
  unsigned int freq;
  unsigned int writes;
  unsigned int reads;
 
public:
  RamAddrStat() { data = freq = writes = reads = 0; };
  ~RamAddrStat() {};
/*  
  char& operator=(RamAddrStat& rval) {
    writes ++;
    rval.reads ++;
    data = rval.data;
    return data;
  }

  char& operator|=(RamAddrStat& rval) {
    writes ++;
    rval.reads ++;
    data |= rval.data;
    return data;
  }

  char& operator+=(RamAddrStat& rval) {
    writes ++;
    rval.reads ++;
    data += rval.data;
    return data;
  }

  char& operator-=(RamAddrStat& rval) {
    writes ++;
    rval.reads ++;
    data -= rval.data;
    return data;
  }
*/
};

//----------------------------------------------------------------

class I8051Ram {
private:
  RamAddrStat RAM[RamSize];
  string RamLocNames[RamSize];
  bool start_log;
  
public:
  I8051Ram();
  ~I8051Ram();

public:
  bool PrintRamAccess(char* output="ramaccess.out");
  void StatLogging(bool);
  char& operator[](unsigned int);
};

#endif





