#ifndef _RAMTRACE_
#define _RAMTRACE_

#include "i8051_const.h"

#define RAMTRACE_RD 0
#define RAMTRACE_WR 1
#define RAMTRACE_RDWR 2

//-----------------------------------------------------------------------

struct RamAddrStat {
  unsigned int freq;
  unsigned int reads;
  unsigned int writes;
};

//-----------------------------------------------------------------------

class RamTrace {
private:
  RamAddrStat RAM[RamSize];
  
public:
  RamTrace();
  ~RamTrace();
  
public:
  unsigned char Update(unsigned char addr, bool read=false);
  bool PrintRamAccess(char* output="ramaccess.out");  
};

#endif
