
#ifndef _CORE_TREE
#define _CORE_TREE

#include <string>
#include <list>
#include "core.h"

#define DELIMETER '/'
#define ROOT_NAME ""

enum print_mode
{
  NORMAL_MODE,
  DU_MODE
};

class core_tree
{
private:
  list <core*> root;
  int total;

  void print_rec(list<core*>,int level);
  void print_du(list<core*>);
public:
  core_tree();
  ~core_tree();
  int insert(string core_name, double power);
  int search(string name, list<core*>::iterator &j, list<core*> &node);
  void print(int mode);
}; 

#endif
