#!/usr/local/bin/perl
$number_args = scalar @ARGV;
$MEGA = 1_000_000;
if($number_args == 2) {
    open(PARSEFILE, $ARGV[0]) or die "Can't open $ARGV[0]: $!\n";
    $total = 0;
    $count = 0;
    $core = 0;
    $core_count = 0;
    while(<PARSEFILE>) {
	chomp;
	s/[\s]+/ /g;
	@line = split/ /;
	$total += $line[4];

	if($line[0] =~ /^$ARGV[1]/i) {
	    $core += $line[4];
	    $core_count++;
	}

	$count++;
    }

    close(PARSEFILE);

    $total = $total * 100 / $MEGA;
    $core = $core * 100 / $MEGA;
    print "total power (mW) = $total\n";
    print "total nets  = $count\n";
    print "core power (mW) = $core\n";
    print "core nets  = $core_count\n";
}
else {
    print "Usage: cpwr <file> <core>\n";
}











